/**
 * jQuery.bind-first library v0.2.3
 * Copyright (c) 2013 Vladimir Zhuravlev
 *
 * Released under MIT License
 * @license
 *
 * Date: Thu Feb  6 10:13:59 ICT 2014
 */
(function(e){function s(t){return i?t.data("events"):e._data(t[0]).events}function o(e,t,n){var r=s(e);var o=r[t];if(!i){var u=n?o.splice(o.delegateCount-1,1)[0]:o.pop();o.splice(n?0:o.delegateCount||0,0,u);return}if(n){r.live.unshift(r.live.pop())}else{o.unshift(o.pop())}}function u(t,n,r){var i=n.split(/\s+/);t.each(function(){for(var t=0;t<i.length;++t){var n=e.trim(i[t]).match(/[^\.]+/i)[0];o(e(this),n,r)}})}var t=e.fn.jquery.split(".");var n=parseInt(t[0]);var r=parseInt(t[1]);var i=n<1||n==1&&r<7;e.fn.bindFirst=function(){var t=e.makeArray(arguments);var n=t.shift();if(n){e.fn.bind.apply(this,arguments);u(this,n)}return this}})(jQuery);

/**
 * jQuery.serializeContainer
 * 	Serializes input elements inside of a container
 */
$.fn.serializeContainer=function(){var o={},e="";return n=this.find(":input").each(function(){e+=(""!=e?"&":"")+$(this).get(0).name+"="+encodeURIComponent($(this).val())}),n=e.split("&"),n.forEach(function(n){var e=n.split("="),i=e[0],t=decodeURIComponent(e[1]);void 0!==o[i]?(o[i].push||(o[i]=[o[i]]),o[i].push(t||"")):o[i]=t||""}),o};


/**
 *	jQuery.ueForms
 * 	Template from http://club15cc.com/code/jquery/an-improved-version-of-the-jquery-plugin-template.
 */
(function ( $ ) {

	var PLUGIN_NS = 'ueForm';

	var Plugin = function ( target, options )
	{
		this.$T = $(target);

		/** #### OPTIONS #### */
		this.options= $.extend(
			true,               // deep extend
			{
				override						: true,
				container						: 'form',
				event								: 'submit',
				duration						: 1500,
        error								: function(code, text){},
        form_error					: function(errors){},
        indefinite					: false,
        name_map						: {
	        ccnum			: "ccnum",
          address		: "address",
          zip				: "zip",
          ccv				: "cvv2",
          expdate		: "expdate",
          magstripe	: "magstripe",
          duration	: "duration"
        }
			},
			options
		);

		this._init( target, this.options );

		/** #### PROPERTIES #### */
		// Here rather than below in Plugin.prototype.myProp and in _init() as this way is DRY-er
		this._request_in_progress = false;
		this._data = {};
		this._obj = null;

		return this;
	}

	/** #### CONSTANTS #### */

	/** #### INITIALISER #### */
  Plugin.prototype._init = function ( target, options )
  {
  	var plugin = this;
  	target.each(function() {
  		$(this).data('_token','');
			plugin._bind( $(this) );
		});
  };

	/** #### PUBLIC API (see notes) #### */


	/** #### PRIVATE METHODS #### */
  Plugin.prototype._hasEvent = function ( obj )
  {
  	return ( obj.data( 'ueForm' ) ) ? true : false;
  }

  Plugin.prototype._bind = function ( obj )
  {
    // Save the plugin context
    var plugin = this;

    // The name of the event to bind to
  	var evnt_nm = this.options.event + '.ue';

		if ( !this.options.override && this._hasEvent( obj ) )
		{
			return;
		}

		this._obj = obj;

  	// If we dont turn off our event first we'll end up with duplicates
  	obj.off(evnt_nm);

		// Bind our function to the event name
		obj.bindFirst(evnt_nm, {}, function(e){
			console.log('fire');
			var first_event = $._data(this).events[plugin.options.event][0];
			var first_event_name = first_event.type+'.'+first_event.namespace;

			// If we're not the first event remove this handler and move us to the front
			if (first_event_name != evnt_nm)
			{
				console.log('not first event');

				$(this).off(evnt_nm);
				plugin._bind($(this));
				$(this).trigger(plugin.options.event);

				// Stop all propagation from this event queue
				// because we're not first
				e.preventDefault();
				if (e.stopImmediatePropagation) e.stopImmediatePropagation();
				if (e.cancelBubble!=null) e.cancelBubble = true;
				e.stopPropagation();
				return false;
			}

			// Skip this event if we already have a token
			if (obj.data('_token')!=='')
			{
				console.log('skip this');
				return true;
			}

			// Save this context
			var that = this;

			// Stop all propagation from this event queue
			// to allow the jsonp call to run "synchronously"
			e.preventDefault();
			if (e.stopImmediatePropagation) e.stopImmediatePropagation();
			if (e.cancelBubble!=null) e.cancelBubble = true;
			e.stopPropagation();

			if ( plugin._request_in_progress )
		  {
				return false;
		  }

			plugin._request_in_progress = true;

			// Target form to serialize
			var target = null;

			if (!$(e.currentTarget).is(plugin.options.container))
			{
				target = $(e.currentTarget).parents(plugin.options.container);
				target = target[0];
			}
			else if ($(e.currentTarget).is(plugin.options.container))
			{
				target = e.currentTarget;
			}

			// The response from our ajax call
			var ajaxResponse;

			// serialize our form values
			var formValues = $(target).serializeContainer();

			// Translate form values based on settings
			$.each(plugin.options.name_map, function(index, value) {
				var form_data = '';
				value = (value instanceof Array) ? value : [value];
				$.each(value, function(mapIndex, mapValue) {
					if ( !formValues.hasOwnProperty( mapValue ) ) return;
					form_data += formValues[mapValue].trim() + ' ';
				});

				plugin._data[index] = form_data.trim();
			});

			// Set the indefinite value to be sent to the server
			plugin._data.indefinite = plugin.options.indefinite;

			// Load the duration into the data to be sent to the server
			if ( plugin._data.duration )
			{
				plugin._data.duration = plugin._data.duration
			}
			else if ( plugin.options.duration )
			{
				plugin._data.duration = plugin.options.duration
			}

			// Strip the credit card number of everything except numbers
			if ( plugin._data.ccnum )
			{
				plugin._data.ccnum = plugin._data.ccnum.replace(/[^0-9]/g, '')
			}

			// Strip the cvv of everything except numbers
			if ( plugin._data.ccv )
			{
				plugin._data.ccv = plugin._data.ccv.replace(/[^0-9]/g, '')
			}

			var errors = {};

			errors.address	= ( plugin._data.address.length ) ? false : true;
			errors.zip			= ( plugin._data.zip.length ) ? false : true;
			errors.ccnum		= ( plugin._data.ccnum.match(/^[0-9]{13,19}$/) != null && plugin._mod10( plugin._data.ccnum )  ) ? false : true;
			errors.ccv			= ( plugin._data.ccv.length ) ? false : true;
			errors.expdate	= ( plugin._data.expdate.length ) ? false : true;

			if ( errors.address || errors.zip || errors.ccnum || errors.ccv || errors.expdate )
			{
				plugin.options.form_error(errors);
				plugin._request_in_progress = false;
				return false;
			}

			plugin._request( target, this );

			plugin._request_in_progress = false;

			return false;
		});
  }

	Plugin.prototype._mod10 = function(creditCardNumber)
	{
		//// 1.	Starting with the check digit double the value of every other digit
		//// 2.	If doubling of a number results in a two digits number, add up
		///   the digits to get a single digit number. This will results in eight single digit numbers
		//// 3. Get the sum of the digits
		var doubled = [];
    for (var i = creditCardNumber.length - 2; i >= 0; i = i - 2)
    {
        doubled.push(2 * creditCardNumber[i]);
    }
    var total = 0;
    for (var i = ((creditCardNumber.length % 2) == 0 ? 1 : 0); i < creditCardNumber.length; i = i + 2)
    {
        total += parseInt(creditCardNumber[i]);
    }
    for (var i = 0; i < doubled.length; i++)
    {
        var num = doubled[i];
        var digit;
        while (num != 0)
        {
            digit = num % 10;
            num = parseInt(num / 10);
            total += digit;
        }
    }

		//// If the final sum is divisible by 10, then the credit card number
		//   is valid. If it is not divisible by 10, the number is invalid.
    if (total % 10 != 0)
    {
        return false;
    }

		// Verify Visa/Amex/MasterCard/Discover
		if (creditCardNumber.substr(0, 2) == 34 || creditCardNumber.substr(0, 2) == 37)
		{
		  return true; // Amex
		}
		else if (creditCardNumber.substr(0, 1) == 4)
		{
		  return true; // Visa
		}
		else if (creditCardNumber.substr(0, 2) >= 50 && creditCardNumber.substr(0, 2) <= 55)
		{
		  return true; // MasterCard
		}
		else if (creditCardNumber.substr(0, 2) == 65 || creditCardNumber.substr(0, 4) == 6011 || creditCardNumber.substr(0, 3) == 644)
		{
		  return true; // Discover
		}

		return false; // Unknown card.
	}

	/*
		my		this context
		obj		context of the object with the event handler
		that	context of the container of the object with the event handler
	*/
	Plugin.prototype._request = function ( that, obj )
  {
		var my = this;

		$.ajax({
			type : 'GET',
			dataType : 'jsonp',
			crossDomain : true,
			jsonp : 'callback',
			jsonpCallback:'callback',
			contentType: "application/json",
			url	:'https://www-stage.usaepay.com/tokenize',
			data : this._data,
			success	: function(ajaxResponse){
				console.log(ajaxResponse)
				if (!ajaxResponse.token)
				{
					var userErrorFn = my.options.error;
					userErrorFn(ajaxResponse.code, ajaxResponse.text);
					return false;
				}

				// Save the token to the plugin instance
				$(obj).data('_token',ajaxResponse.token)
				// Replace the credit_card_number field with the token if its one field
				// If its several then remove it and create the ueForm-token input.
				if (typeof my.options.name_map.ccnum === 'string'){
					$(that).find("input[name='"+my.options.name_map.ccnum+"']").val(ajaxResponse.token);
				} else {
					// Load a ueForm-token field with the token response
					$(that).append('<input type="hidden" name="ueForm-token" value="' + ajaxResponse.token + '" />');
					// Blank out all cc data
					$.each(my.options.name_map.ccnum,function(index,part){
						$(that).find("input[name='"+part+"']").val('');
					})
				}
				// Remove the ccv
				if (typeof my.options.name_map.ccv === 'string'){
					// Single input
					$(that).find("input[name='"+my.options.name_map.ccv+"']").val('');
				} else {
					// Multi part input
					$.each(my.options.name_map.ccv,function(index,part){
						$(that).find("input[name='"+part+"']").val('');
					})
				}

				// Load a ueForm-tokenExpiration field with the token response
				$(that).append('<input type="hidden" name="ueForm-tokenExpiration" value="' + ajaxResponse.expire_datetime + '" />');

				console.log('trigger '+my.options.event);

				// Retrigger the event queue
				$(obj).trigger(my.options.event);
			}
		});

  }

	/*###################################################################################
	* JQUERY HOOK
	###################################################################################*/

	/**
   * Generic jQuery plugin instantiation method call logic
   *
   * Method options are stored via jQuery's data() method in the relevant element(s)
   * Notice, myActionMethod mustn't start with an underscore (_) as this is used to
   * indicate private methods on the PLUGIN class.
   */
	// Called with a selector.
	$.fn[ PLUGIN_NS ] = function( methodOrOptions )
	{
		if (!$(this).length)
		{
			return $(this);
		}

		var instance = $(this).data(PLUGIN_NS);

	  // CASE: action method (public method on PLUGIN class)
	  if ( instance
			&& typeof( methodOrOptions ) == 'String'
			&& methodOrOptions.indexOf('_') != 0
			&& instance[ methodOrOptions ]
			&& typeof( instance[ methodOrOptions ] ) == 'function' ) {

				return instance[ methodOrOptions ]( Array.prototype.slice.call( arguments, 1 ) );

	  // CASE: argument is options object or empty = initialise
	  } else if ( typeof methodOrOptions === 'object' || ! methodOrOptions ) {

			instance = new Plugin( $(this), methodOrOptions );    // ok to overwrite if this is a re-init
	    $(this).data( PLUGIN_NS, instance );
	    return $(this);

	  // CASE: method called before init
	  } else if ( !instance ) {
			$.error( 'Plugin must be initialised before using method: ' + methodOrOptions );

	  // CASE: invalid method
	  } else if ( methodOrOptions.indexOf('_') == 0 ) {
			$.error( 'Method ' +  methodOrOptions + ' is private!' );
	  } else {
			$.error( 'Method ' +  methodOrOptions + ' does not exist.' );
	  }
	};
})( jQuery );

// Executed by default to hook into all forms on the page.
// Override false and bindFirst so we dont clobber any ueForm plugins attached before this executes.
$(document)
	.bindFirst('ready',function(){
		//$('form').ueForm({override:false});
	});